function Savings(Generation, Area_Thresh, Power_Thresh)

status = 0;

%Extract original area data from file.
if exist('../Original/output/area_rpt','file')
    fid = fopen('../Original/output/area_rpt');
    target = 'Total cell area';
    n = length(target);
    match = 0;
    tmp = fgetl(fid);
    while (~match)
        tmp = fgetl(fid);
        match = strncmpi(tmp,target,n);
    end
    fclose(fid);
    tmp(strfind(tmp, ' ')) = [];
    index = strfind(tmp,':');
    Original_area = sscanf(tmp(index+1:end),'%f',1);
else
    display('No area report for original design. Data analysis break...');
    status = -1;
end

%Extract original power data from file.
if exist('../Original/output/pwr_rpt','file')
    fid = fopen('../Original/output/pwr_rpt');
    target = 'Total Dynamic Power';
    n = length(target);
    match = 0;
    tmp = fgetl(fid);
    while (~match)
        tmp = fgetl(fid);
        match = strncmpi(tmp,target,n);
    end
    fclose(fid);
    tmp(strfind(tmp, ' ')) = [];
    index = strfind(tmp,'=');
    Original_power = sscanf(tmp(index+1:end),'%f',1);
    index = strfind(tmp, '(');
    unit = sscanf(tmp(index-2:index-1),'%s');
    if (unit == 'uW')
        Original_power = Original_power/1000;
    end
else
    display('No power report for original design. Data analysis break...');
    status = -1;
end    

%Extract modified area data from file.
if exist('../Modified/output/area_rpt','file')
    fid = fopen('../Modified/output/area_rpt');
    target = 'Total cell area';
    n = length(target);
    match = 0;
    tmp = fgetl(fid);
    while (~match)
        tmp = fgetl(fid);
        match = strncmpi(tmp,target,n);
    end
    fclose(fid);
    tmp(strfind(tmp, ' ')) = [];
    index = strfind(tmp,':');
    Modified_area = sscanf(tmp(index+1:end),'%f',1);
else
    display('No area report for modified design. Data analysis break...');
    status = -2;
end 

%Extract modified power data from file.
if exist('../Modified/output/pwr_rpt','file')
    fid = fopen('../Modified/output/pwr_rpt');
    target = 'Total Dynamic Power';
    n = length(target);
    match = 0;
    tmp = fgetl(fid);
    while (~match)
        tmp = fgetl(fid);
        match = strncmpi(tmp,target,n);
    end
    fclose(fid);
    tmp(strfind(tmp, ' ')) = [];
    index = strfind(tmp,'=');
    Modified_power = sscanf(tmp(index+1:end),'%f',1);
    index = strfind(tmp, '(');
    unit = sscanf(tmp(index-2:index-1),'%s');
    if (unit == 'uW')
        Modified_power = Modified_power/1000;
    end
else
    display('No power report for modified design. Data analysis break...');
    status = -2;
end    



if exist(sprintf('./Data/FilesInfo_G%d.txt', Generation), 'file')
    fid0 = fopen(sprintf('./Data/FilesInfo_G%d.txt', Generation), 'a');
    if status == 0
        Area_saving = 100*(Original_area - Modified_area)/Original_area;
        Power_saving = 100*(Original_power - Modified_power)/Original_power;
	if ((Area_saving > Area_Thresh) && (Power_saving > Power_Thresh))
	        fprintf(fid0,'%0.6g\t\t%0.6g\n', Area_saving, Power_saving); 
	else
		fprintf(fid0,'%0.6g\t\t%0.6g\n', Area_saving, Power_saving); 
		%display(sprintf('Area And\/OR Power savings not acceptable'));
		fclose(fid0);
		status = -3;
		display(status);
		exit;
	end
        display(sprintf('Total cell area :\tOriginal = %d um^2,\tModified = %d um^2, \tSaving = %0.6g %% \n', Original_area, Modified_area, Area_saving));
        display(sprintf('Total dynamic power :\tOriginal = %d mW,\tModified = %d mW, \tSaving = %0.6g %% \n', Original_power, Modified_power, Power_saving));
    elseif status == -2
        fprintf(fid0,'-100\t\t-100\n'); 
    end    
    fclose(fid0);
    display(status);
    exit;
else
    display(sprintf('Failed to open FilesInfo_G%d.txt, no data collected...',Generation));
    status = -1
    exit;
end
