import time
import os
import numpy
import math
from scipy  import *
from scipy import io, signal, linalg
import string as st
import matplotlib
matplotlib.use('agg')
from matplotlib import pyplot as plt



coefLength=25
startIndex=53
#wordLenth=8

output_data_file= '../Modified/SRC/output.txt'


def output_to_im(filename):
		f=open(filename)
		f2=open('dataout.txt','w')

		data=[]
		dataout=[0]*coefLength
		
		data=f.readlines()
		
		f.close()
		
		for m in range(startIndex,startIndex+coefLength-1):
			sum=0
			signBit=data[m][1]
			relevant_bits=data[m][2:len(data[m])-3]
			#print relevant_bits

			if (signBit=='1'):
				one_subtracted=numpy.binary_repr(int(relevant_bits,2)-1)
				one_subtracted_inv=one_subtracted.replace('1','x').replace('0','1').replace('x','0')
				relevant_bits=one_subtracted_inv
				
			for i in range(0, len(relevant_bits)-1):
				sum=sum+int(relevant_bits[i])*pow(2,-(i+1))
			if (signBit=='1'):
				dataout[m-53]=-sum
			else:
				dataout[m-53]=sum
			f2.write(str(sum)+"\n")
			
		f2.close()		
		return dataout
		
def main(Generation,VlogFile,max_allowed_MSE,min_allowed_NCC):
	Design='fir_filter_fr'
	status=0
	#max_allowed_MSE=100
	#min_allowed_NCC=0.90

	start_time=time.clock()

	actual_im_response = output_to_im(output_data_file)

	coef_metadata=io.loadmat('../Original/SRC/coef.mat')
	coef_temp=list(coef_metadata["coef"])

	coef=[]
	for numbers in coef_temp:
		coef=numbers.astype(float)
        

	ideal_im_in = [0]*coefLength
	ideal_im_in[0]=1

	ideal_im_response = signal.lfilter(coef,1,ideal_im_in)




	#filter response
	ideal_fr_response=fft(ideal_im_response,2048)
	ideal_fr_response=20*log10(abs(ideal_fr_response[0:1024]))

	actual_fr_response=fft(actual_im_response,2048)
	actual_fr_response=20*log10(abs(actual_fr_response[0:1024]))
	#print (actual_fr_response)
	#print len(actual_fr_response)
	if((str(min(actual_fr_response))=='-inf') or (str(max(actual_fr_response))=='inf') or (str(min(actual_fr_response))=='nan')):
		actual_fr_response=[0]*1024

	plt.figure(1)
	plt.subplot(121)
	x=[x for x in range(1,26)]
	plt.plot(x,ideal_im_response,'r')
	plt.plot(x,actual_im_response,'--bo')
	#plt.show()



	plt.subplot(122)
	x=linspace(0,1,1024)
	plt.plot(x,ideal_fr_response,'r')
	plt.plot(x,actual_fr_response,'b')
	figurename='figure_G%d_F%d'%(Generation,VlogFile)
	plt.savefig('%s.pdf'%figurename)
	plt.close('all')

	#comparison between ideal and actual

	def norm_cross_corr(x,y):
                norm_x=linalg.norm(x,2)
                norm_y=linalg.norm(y,2)

                if(norm_x==0): norm_x=1e-7
                if(norm_y==0): norm_y=1e-7
                return max(abs(correlate(x,y)))/(norm_x * norm_y)

	def mean_sq_diff(x,y): return mean(pow((x-y),2))
		
	NCC = norm_cross_corr(ideal_fr_response, actual_fr_response)
	MSE = mean_sq_diff(ideal_fr_response, actual_fr_response)

	#print NCC
	#print MSE
	
	if ((MSE>max_allowed_MSE) or  (NCC<min_allowed_NCC)):
		status= -1
		print "\n--Failed to analyze filter response. Trying again--\n"
		return

	if (os.path.isfile('./Data/FilesInfo_G%d.txt'%Generation)):
		f3=open('./Data/FilesInfo_G%d.txt'%Generation,'a')
		if (status==0):
			content='%s_G%d_F%d.v\t%g\t\t%g\t'%(Design,Generation,VlogFile,MSE,NCC)	
			f3.write(content)
	#		f2.write('%d\t\t%d' %(MSE,NCC))
		f3.close()
	else:
		status= -1

	run_time=time.clock()-start_time

	if status==0 : print "\n--Successfully analyzed Filter Response, runtime: %gs--\n"%run_time 
	else: print "\n--Failed to analyze filter response. Try Again, runtime: %fs--\n"%run_time
	

	return status
		



