function [target_header] = simulation_feedback()
clear all;
clc;

input_sim_result = 'sim_vars.txt';  
input_sim_result_bin = 'sim_vars_bin.txt';

fid=fopen(input_sim_result);
fid2=fopen(input_sim_result_bin);
header_metadata = textscan(fid, '%s', 1, 'delimiter','\t');
header_metadata = textscan(char(header_metadata{1,1}), '%s');
header = char(header_metadata{1,1}');


%to make parsing easier
header = strcat(header, '+');



[data] = textscan(fid, '%s', 'delimiter', '\t');
% flat = zeros(length(data{1,1}), max(cellfun('length', data{1,1}))); 

temp3= zeros(length(data{1,1}),length(header));
for i=1:length(data{1,1})
    temp = cell2mat(data{1,1}(i,:));
    flat(i,1:length(temp)) = temp;
    flat(flat=='x')='0'; flat(flat=='X')='0';
    temp2(i) = textscan(flat(i,:),'%s');    
   
end


temp2=temp2';
t=2;

for j = 1:length(temp2)
    for k = 1:length(temp2{1,1})
        temp3(j,k)=str2num(cell2mat(temp2{j,1}(k)));
    end
end

%bin data

header_metadata_bin = textscan(fid2, '%s', 1, 'delimiter','\t');
[data_bin] = textscan(fid2, '%s', 'delimiter', '\t');
% flat = zeros(length(data{1,1}), max(cellfun('length', data{1,1}))); 

temp3_bin= zeros(length(data_bin{1,1}),length(header));
for i=1:length(data_bin{1,1})
    temp_bin = cell2mat(data_bin{1,1}(i,:));
    temp_bin(temp_bin=='x')='0';
    flat_bin(i,1:length(temp_bin)) = temp_bin;
    flat_bin(flat_bin=='?')='0';
    flat_bin(flat_bin=='+')='0';
    
    temp2_bin(i) = textscan(flat_bin(i,:),'%s');    
   
end


temp2_bin=temp2_bin';
t_bin=2;
temp3_bin= cell(length(data_bin{1,1}),length(header));

for j = 1:length(temp2_bin)
    for k = 1:length(temp2_bin{1,1})
        temp3_bin{j,k}=temp2_bin{j,1}(k);
    end
end

%end bin data processing



idx=0;
val=0;
for m = 1:size(temp3,2)
    temp_array = temp3(:,m);
    mean_val = mean(temp_array);
    if (abs((mean_val-0))>5)
        temp_array(temp_array==0)=NaN;
    end
    noNan_array=temp_array(~isnan(temp_array));
    mean_val = mean(noNan_array);
    std_val = std(noNan_array);
    if (std_val < (10/(range(noNan_array))))
        idx = [idx m];
        val = [val mean_val];
       
    end  
    
    
end


for n = 2:length(idx)
    temp_target_header(n-1,:)= header(idx(n),1:end);
    temp_mean_val(n-1,:) = val(n);
end

target_header = cell2mat((cellstr(temp_target_header))');
%target_mean_val =temp_mean_val';

idx = idx(2:end);
val = val(2:end);

display='';
for o = 1:length(idx)
    target_mean_val{1,o} = temp3_bin{ceil(length(temp3_bin)/2), idx(o)};
    temp_holder = cell2mat(target_mean_val{o});
    length_temp_holder = length(temp_holder);
    display = [display strcat(header(idx(o),1:end),num2str(length_temp_holder),'\''b',temp_holder,'+',num2str(length_temp_holder),'+')];
end
    

fprintf('Target_header and value: %s', display);


fclose(fid);
fclose(fid2);
end
